/* AMX Mod script.
 *
 * (c) 2004, SidLuke, Vapok
 * This file is provided as is (no warranties).
 *
 * Plugin works with Stats Settings Plugin. Just run both of them.
 * By amx_statscfg command, you will be able to set all settings
 * and save them to a file.
 *
 * Example of usage for some options:
 * amx_statscfg on SayTop15
 * amx_statscfg on SayRank
 *
 * Accepts also parts of name:
 * amx_statscfg off say
 * amx_statscfg on End
 *
 * For DoDXMod Version 1.4
 *
 * Updated by KRoT@L.
 *
 */

#include <translator>
#include <amxmod>
#include <amxmisc>
#include <dodxmod>
#include <VexdUM>

#define AUTOMATIC_PRECACHING

#define MAX_MENUPOS 7     // positions in dodstatsmenu

//public EndPlayer          // displays player stats at the end of map
//public EndTop15           // displays top15 at the end of map

public SayStatsAll        // displays players stats and rank
public SayTop15           // displays first 15. players, amx_dodstats_topvalue really :)
public SayFlop15          // displays worst 15. players, amx_dodstats_topvalue really :)
public SayRank            // displays user position in rank
public SayStatsMe         // displays user stats

public ShowAttackers      // shows attackers
public ShowVictims        // shows victims
public ShowKiller         // shows killer
public KillerHp           // displays killer hp to victim console and screen
public SayHP              // displays information about user killer
public SayFF              // displays friendly fire status

public MultiKill
public MultiKillSound
public KnifeKill
public KnifeKillSound
public GrenadeKill
public GrenadeKillSound
public GrenadeSuicide
public GrenadeSuicideSound
public HeadShotKill
public HeadShotKillSound
public KillingStreak
public KillingStreakSound
public DoubleKill
public DoubleKillSound
public BulletDamage
public TAInfo
public RoundScore
public EndRoundStats
public GreCatch
public GreCatchSound
public EnemyGreKill
public EnemyGreKillSound
public LeadSounds
public Suicide
public AirKill
public WaterKill


new g_streakKills[33][2]
new g_multiKills[33][2]
new Float:g_prevKill
new g_prevKillerId
new g_KillCount
new g_RoundScore[2] = {0, 0}

new g_userPosition[33] = {0,...}
new g_userState[33] = {0,...}
new g_userPlayers[33][32]
new g_Buffer[2048] = ""
new g_Killers[33][3]
new Float:g_DeathStats[33] = {0.0,...}

new g_maxplayers
new g_vexdRunning

new g_MultiKillMsg[7][] = {
  "Multi-Kill! %s^nwith %d kills (%d hs)",
  "Ultra-Kill!!! %s^nwith %d kills (%d hs)",
  "%s IS ON A KILLING SPREE!!!^nwith %d kills (%d hs)",
  "RAMPAGE!!! %s^nwith %d kills (%d hs)" ,
  "%s IS UNSTOPPABLE!!!^nwith %d kills (%d hs)" ,
  "%s IS A MONSTER!^nwith %d kills (%d hs)",
  "%s IS GODLIKE!!!!^nwith %d kills (%d hs)"
}
new g_Sounds[7][] = {
  "misc/multikill",
  "misc/ultrakill",
  "misc/killingspree",
  "misc/rampage",
  "misc/unstoppable",
  "misc/monsterkill",
  "misc/godlike"
}
new g_KillingMsg[7][] = {
  "%s: Multi-Kill!",
  "%s: Ultra-Kill!!!",
  "%s IS ON A KILLING SPREE!!!",
  "%s: RAMPAGE!!!",
  "%s IS UNSTOPPABLE!!!",
  "%s IS A MONSTER!",
  "%s IS GODLIKE!!!"
}
new g_KnifeMsg[4][] = {
  "%s sliced and diced %s",
  "%s pulled out knife and gutted %s",
  "%s sneaked carefully behind and knifed %s",
  "%s knifed %s"
}
new g_HeMessages[4][] = {
  "%s sends a little gift to %s",
  "%s throws a small present to %s",
  "%s made a precision throw to %s",
  "%s got a big explosion for %s"
}
new g_SHeMessages[4][] = {
  "%s detonated himself with a grenade",
  "%s tried the effect of a grenade",
  "%s kicked a grenade into his own ass",
  "%s exploded!"
}
new g_HeadShots[7][] = {
  "$kn killed $vn with a well^nplaced shot to the head!",
  "$kn removed $vn's^nhead with the $wn",
  "$kn turned $vn's head^ninto pudding with the $wn",
  "$vn got pwned by $kn",
  "$vn's head has been^nturned into red jello",
  "$kn has superb aim with the $wn,^nas $vn well knows",
  "$vn's head stayed in $kn's^ncrosshairs a bit too long..."
}
new g_DoubleKillMsg[3][] = {
  "Wow! %s made a double kill!!!",
  "Incredible! %s made a triple kill!!!",
  "Amazing! %s made %d kills at once!!!"
}
new g_DoubleKillSound[3][] = {
  "misc/doublekill",
  "misc/multikill",
  "misc/godlike"
}
new g_SuicideMessages[2][] = {
  "%s knows how the kill command works!",
  "%s prefered to kill himself rather than die on the field!"
}
new g_AirKillMessages[3][] = {
  "$vn was killed by $kn^nwhile he was in the air",
  "$vn was killed by $kn^nwhile he was flying like a pigeon",
  "$vn could not reach the ground^nbecause he was shot in the air by $kn"
}
new g_WaterKillMessages[3][] = {
  "$vn was killed by $kn^nwhile he was in the water",
  "$vn was killed by $kn^nwhile has was having a bath",
  "$vn was killed by $kn^nwhile he was having a wash"
}

new g_bodyParts[8][] = {
  "wholebody",
  "head",
  "chest",
  "stomach",
  "leftarm",
  "rightarm",
  "leftleg",
  "rightleg"
}

new g_addStast[] = "amx_statscfg add ^"%s^" %s"
new g_disabledMsg[] = "Server has disabled that option"


public disable_natives_check() {
  // temporary name and way of functioning
  // don't use that in your plugins for the moment
}

public plugin_init() {
  load_translations("dodx_stats")
  register_plugin(_T("DoDX Stats"),AMX_VERSION,"AMX Team") // by SidLuke/Vapok/KRoT@L
  //register_event("30","eInterMission","a")
  register_event("ResetHUD","eResetHud","b")

  register_event("RoundState","round_end","a","1=3","1=4")
  register_event("RoundState","show_score","a","1=1")
  register_event("CurWeapon","NadeCatch","b","1=1","2=15","2=16")
  register_event("ObjScore","get_score","a")

  register_clcmd("say /hp","cmdKiller",0,_T("- displays info. about your killer"))
  register_clcmd("say /stats","cmdStats",0,_T("- displays others stats"))
  register_clcmd("say /statsme","cmdStatsMe",0,_T("- displays your stats"))
  register_clcmd("say /top15","cmdTop15",0,_T("- displays top 15 players"))
  register_clcmd("say /top10","cmdTop15",0,_T("- displays top 15 players")) // for statsme users :)
  register_clcmd("say /flop15","cmdFlop15",0,_T("- displays worst 15 players"))
  register_clcmd("say /rank","cmdRank",0,_T("- displays your server stats"))
  register_clcmd("say /ff","cmdFF",0,_T("- displays friendly fire status"))
  register_menucmd(register_menuid("Server Stats"),1023,"actionStatsMenu")
  
  register_cvar("amx_dodstats_topvalue","12")
  register_cvar("amx_dodstats_duration","5.0")
  
  g_maxplayers = get_maxplayers()
  g_vexdRunning = (is_module_running("VexdUM"))
  g_Buffer[0] = '^0'
}

public plugin_precache() {
  new filename[64]
  build_path(filename, 63, "$configdir/stats.ini")
  if(file_exists(filename)) {
    new text[256], name[32]
    new len, pos = 0, xid
    while((pos = read_file(filename, pos, text, 255, len))) {
      if(text[0] == ';' || !len) continue // line is a comment
      parse(text, name, 31)
      if((xid = get_xvar_id(name)) != -1)
        set_xvar_num(xid, 1)
    }
  }
#if defined AUTOMATIC_PRECACHING
  if(MultiKillSound || KillingStreakSound) {
    for(new i = 0; i < 7; i++)
      precache_sound_custom(g_Sounds[i])
  }
  if(KnifeKillSound) {
    precache_sound_custom("misc/humiliation")
  }
  if(GrenadeKillSound) {
    precache_sound_custom("djeyl/grenade")
  }
  if(GrenadeSuicideSound) {
    precache_sound_custom("djeyl/witch")
  }
  if(HeadShotKillSound) {
    precache_sound_custom("misc/headshot")
  }
  if(DoubleKillSound) {
    precache_sound_custom("misc/doublekill")
    if(!(MultiKillSound || KillingStreakSound)) {
      precache_sound_custom("misc/multikill")
      precache_sound_custom("misc/godlike")
    }
  }
  if(GreCatchSound) {
    precache_sound_custom("misc/impressive")
  }
  if(EnemyGreKillSound && !(MultiKillSound || KillingStreakSound || DoubleKillSound)) {
    precache_sound_custom("misc/godlike")
  }
  if(LeadSounds) {
    precache_sound_custom("misc/takenlead")
    precache_sound_custom("misc/tiedlead")
    precache_sound_custom("misc/lostlead")
  }
#endif
}

public precache_sound_custom(sound[]) {
  new file[64]
  format(file, 63, "sound/%s.wav", sound)
  if(file_exists(file)) {
    replace(file, 63, "sound/", "")
    precache_sound(file)
  }
}

public plugin_cfg(){
  server_cmd(g_addStast,"Show Attackers","ShowAttackers")
  server_cmd(g_addStast,"Show Victims","ShowVictims")
  server_cmd(g_addStast,"Show Killer","ShowKiller")
  server_cmd(g_addStast,"Show Killer HP","KillerHp")
  
  server_cmd(g_addStast,"Say /hp","SayHP")
  server_cmd(g_addStast,"Say /ff","SayFF")
  server_cmd(g_addStast,"Say /stats","SayStatsAll")
  server_cmd(g_addStast,"Say /top15","SayTop15")
  server_cmd(g_addStast,"Say /flop15","SayFlop15")
  server_cmd(g_addStast,"Say /rank","SayRank")
  server_cmd(g_addStast,"Say /statsme","SayStatsMe")
  
  //server_cmd(g_addStast,"Stats at the end of map","EndPlayer")
  //server_cmd(g_addStast,"Top15 at the end of map","EndTop15")

  server_cmd(g_addStast,"MultiKill","MultiKill")
  server_cmd(g_addStast,"MultiKill Sound","MultiKillSound")
  server_cmd(g_addStast,"Knife Kill","KnifeKill")
  server_cmd(g_addStast,"Knife Kill Sound","KnifeKillSound")
  server_cmd(g_addStast,"Grenade Kill","GrenadeKill")
  server_cmd(g_addStast,"Grenade Kill Sound","GrenadeKillSound")
  server_cmd(g_addStast,"Grenade Suicide","GrenadeSuicide")
  server_cmd(g_addStast,"Grenade Suicide Sound","GrenadeSuicideSound")
  server_cmd(g_addStast,"HeadShot Kill","HeadShotKill")
  server_cmd(g_addStast,"HeadShot Kill Sound","HeadShotKillSound")
  server_cmd(g_addStast,"Killing Streak","KillingStreak")
  server_cmd(g_addStast,"Killing Streak Sound","KillingStreakSound")
  server_cmd(g_addStast,"Double Kill","DoubleKill")
  server_cmd(g_addStast,"Double Kill Sound","DoubleKillSound")
  server_cmd(g_addStast,"Bullet Damage","BulletDamage")
  server_cmd(g_addStast,"TA/TK Info","TAInfo")
  server_cmd(g_addStast,"Round Score","RoundScore")
  server_cmd(g_addStast,"End Round Stats","EndRoundStats")
  server_cmd(g_addStast,"Grenade Catch","GreCatch")
  server_cmd(g_addStast,"Grenade Catch Sound","GreCatchSound")
  server_cmd(g_addStast,"Enemy Grenade Kill","EnemyGreKill")
  server_cmd(g_addStast,"Enemy Grenade Kill Sound","EnemyGreKillSound")
  server_cmd(g_addStast,"Lead Sounds","LeadSounds")
  server_cmd(g_addStast,"Suicide","Suicide")
  if(g_vexdRunning) {
    server_cmd(g_addStast,"Air Kill","AirKill")
    server_cmd(g_addStast,"Water Kill","WaterKill")
  }
}

public client_connect(id) {
  g_streakKills[id] = {0, 0}
  g_multiKills[id] = {0, 0}
  g_userPosition[id] = 0
  g_userState[id] = 0
  g_Killers[id] = {0, 0, 0}
  g_DeathStats[id] = 0.0
}

public cmdFF(id) {
  if(!SayFF) {
    client_print(id, print_chat, _T(g_disabledMsg))
    return PLUGIN_HANDLED
  }
  client_print(0, print_chat, _T("Friendly fire:  %s"), (get_cvar_num( "mp_friendlyfire")) ? _T("ON") : _T("OFF"))
  return PLUGIN_CONTINUE
}

public cmdStatsMe(id) {
  if(!SayStatsMe || !isDXMActive()) {
    client_print(id, print_chat, _T(g_disabledMsg))
    return PLUGIN_HANDLED
  }
  displayStats(id, id)
  return PLUGIN_CONTINUE
}

public displayStats(id,dest) {
  new name[32], stats[9], body[8]
  get_user_wstats(id, 0, stats, body)
  new pos = copy(g_Buffer, 2047,
                "<html><head><style type=^"text/css^">pre{color:#FFB000;}body{background:#000000;margin-left:8px;margin-top:0px;}</style></head><pre><body>")
  pos += format(g_Buffer[pos], 2047-pos,
                "%9s %9s %9s %4s %9s %9s %4s<hr color=^"#FFB000^">",
                _T("Kills:",dest),_T("Deaths:",dest),_T("Score:",dest),_T("TKs:",dest),_T("Hits:",dest),_T("Shots:",dest),_T("HS:",dest))
  pos += format(g_Buffer[pos], 2047-pos,
                "%9d %9d %9d %4d %9d %9d %4d^n^n^n",
                stats[0],stats[1],stats[7],stats[3],stats[5],stats[4],stats[2])
  pos += format(g_Buffer[pos], 2047-pos,
                "%-16s %9s %9s %9s %9s %9s<hr color=^"#FFB000^">",
                _T("Weapon:",dest),_T("Shots:",dest),_T("Hits:",dest),_T("Damage:",dest),_T("Kills:",dest),_T("Deaths:",dest))
  for(new a = 1; a < DODMAX_WEAPONS; ++a) {
   if(get_user_wstats(id, a, stats, body)) {
     if(dod_is_melee(a))
       stats[4] = -1
     dod_get_wpnname(a, name, 31)
     pos += format(g_Buffer[pos], 2047-pos,
                   "<b>%-16s</b> %9d %9d %9d %9d %9d^n",
                   name,stats[4],stats[5],stats[6],stats[0],stats[1])
   }
  }
  format(g_Buffer[pos], 2047-pos, "</pre></body></html>")
  get_user_name(id, name, 31)
  show_motd(dest, g_Buffer, name)
  return PLUGIN_CONTINUE
}

public cmdRank(id) {
  if(!SayRank || !isDXMActive()) {
    client_print(id, print_chat, _T(g_disabledMsg))
    return PLUGIN_HANDLED
  }
  displayRank(id, id)
  return PLUGIN_CONTINUE
}

displayRank(id,dest) {
  new name[32], stats[9], body[8]
  new rank_pos = get_user_stats(id, stats, body)
  new pos = copy(g_Buffer, 2047,
                 "<html><head><style type=^"text/css^">pre{color:#FFB000;}body{background:#000000;margin-left:8px;margin-top:0px;}</style></head><pre><body>")
  pos += format(g_Buffer[pos], 2047-pos,
               "%9s %9s %9s %4s %9s %9s %4s<hr color=^"#FFB000^">",
               _T("Kills:",dest),_T("Deaths:",dest),_T("Score:",dest),_T("TKs:",dest),_T("Hits:",dest),_T("Shots:",dest),_T("HS:",dest))
  pos += format(g_Buffer[pos], 2047-pos,
               "%9d %9d %9d %4d %9d %9d %4d^n^n",
               stats[0],stats[1],stats[7],stats[3],stats[5],stats[4],stats[2])
  pos += format(g_Buffer[pos], 2047-pos,
               "%s<hr align=^"left^" width=^"200^" color=^"#FFB000^">%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d<hr color=^"#FFB000^">",
               _T("Hits",dest),_T(g_bodyParts[1],dest),body[1],_T(g_bodyParts[2],dest),body[2],_T(g_bodyParts[3],dest),body[3],_T(g_bodyParts[4],dest),body[4],
               _T(g_bodyParts[5],dest),body[5],_T(g_bodyParts[6],dest),body[6],_T(g_bodyParts[7],dest),body[7])
  pos += format(g_Buffer[pos],2047-pos,"%s <b>%d</b> %s <b>%d</b>",(id==dest)?_T("Your rank is",dest):_T("His rank is",dest),rank_pos,_T("of",dest),get_statsnum())
  format(g_Buffer[pos], 2047-pos, "</pre></body></html>")
  get_user_name(id, name, 31)
  show_motd(dest, g_Buffer, name)
}

public cmdTop15(id) {
  if(!SayTop15 || !isDXMActive()) {
    client_print(id, print_chat, _T(g_disabledMsg))
    return PLUGIN_HANDLED
  }
  new title[16]
  format(title, 15, _T("Top %d",id), get_cvar_num("amx_dodstats_topvalue"))
  getTop15(id)
  show_motd(id, g_Buffer, title)
  return PLUGIN_CONTINUE
}

getTop15(id) {
  new stats[9], body[8], name[32], oldpos = 0
  new pos = copy(g_Buffer, 2047,
                 "<html><head><style type=^"text/css^">pre{color:#FFB000;}body{background:#000000;margin-left:8px;margin-top:0px;}</style></head><pre><body>")
  pos += format(g_Buffer[pos], 2047-pos,
                " #  %-22.22s %9s %9s %9s %4s %9s %9s %4s<hr color=^"#FFB000^">",
                _T("Nick:",id),_T("Kills:",id),_T("Deaths:",id),_T("Score:",id),_T("TKs:",id),_T("Hits:",id),_T("Shots:",id),_T("HS:",id))

  new iMax = get_statsnum()
  new iTopPlayers = get_cvar_num("amx_dodstats_topvalue")
  if(iMax > iTopPlayers)
    iMax = iTopPlayers

  for(new a = 0; a < iMax && 2047-pos >= 20; ++a) {
    get_stats(a, stats, body, name, 31)
    oldpos = pos
    pos += format(g_Buffer[pos], 2047-pos,
                  "%2d. %-22.22s %9d %9d %9d %4d %9d %9d %4d^n",
                  a+1,name,stats[0],stats[1],stats[7],stats[3],stats[5],stats[4],stats[2])
    while(2047 - pos > 2 && replace(g_Buffer[oldpos], 2047 - oldpos, "<", "&lt;")) {
      pos += 3;
    }
  }
  if(pos+20 <= 2047) format(g_Buffer[pos], 2047-pos, "</pre></body></html>")
}

public cmdFlop15(id) {
  if(!SayFlop15 || !isDXMActive()) {
    client_print(id, print_chat, _T(g_disabledMsg))
    return PLUGIN_HANDLED
  }
  new title[16]
  format(title, 15, _T("Flop %d",id), get_cvar_num("amx_dodstats_topvalue"))
  getFlop15(id)
  show_motd(id, g_Buffer, title)
  return PLUGIN_CONTINUE
}

getFlop15(id) {
  new stats[9], body[8], name[32], oldpos = 0
  new pos = copy(g_Buffer, 2047,
                 "<html><head><style type=^"text/css^">pre{color:#FFB000;}body{background:#000000;margin-left:8px;margin-top:0px;}</style></head><pre><body>")
  pos += format(g_Buffer[pos], 2047-pos,
                " #  %-22.22s %9s %9s %9s %4s %9s %9s %4s<hr color=^"#FFB000^">",
                _T("Nick:",id),_T("Kills:",id),_T("Deaths:",id),_T("Score:",id),_T("TKs:",id),_T("Hits:",id),_T("Shots:",id),_T("HS:",id))

  new iMax = get_statsnum()
  new iMin = iMax - get_cvar_num("amx_dodstats_topvalue")

  if( iMin < 0 )
    iMin = 0

  for(new a = iMax-1; a >= iMin && 2047-pos >= 20; --a) {
    get_stats(a, stats, body, name, 31)
    oldpos = pos
    pos += format(g_Buffer[pos], 2047-pos,
                  "%2d. %-22.22s %9d %9d %9d %4d %9d %9d %4d^n",
                  iMax-a,name,stats[0],stats[1],stats[7],stats[3],stats[5],stats[4],stats[2])
    while(2047 - pos > 2 && replace(g_Buffer[oldpos], 2047 - oldpos, "<", "&lt;")) {
      pos += 3;
    }
  }
  if(pos+20 <= 2047) format(g_Buffer[pos], 2047-pos, "</pre></body></html>")
}

/*public endGameStats() {
  new i
  if(EndPlayer) {
    new players[32], inum
    get_players(players, inum, "c")
    for(i = 0; i < inum; ++i) {
      displayStats(players[i],players[i])
    }
  }
  else if(EndTop15) {
    new players[32], inum
    get_players(players, inum, "c")
    for(i = 0; i < inum; ++i) {
      new title[16]
      format(title, 15, _T("Top %d",players[i]), get_cvar_num("amx_dodstats_topvalue"))
      getTop15(players[i])
      show_motd(players[i], g_Buffer, title)
    }
  }
}*/

/*public eInterMission() {
  if(isDXMActive()) {
    set_task(1.0, "endGameStats", 73874154)
  }
}*/

public cmdStats(id) {
  if(!SayStatsAll || !isDXMActive()) {
    client_print(id, print_chat, _T(g_disabledMsg))
    return PLUGIN_HANDLED
  }
  showStatsMenu(id, g_userPosition[id]=0)
  return PLUGIN_CONTINUE
}

/* build list of attackers */
getAttackers(id) {
  new name[32], wpn[32], stats[9], body[8], found=0
  new pos = format(g_Buffer, 2047, _T("Attackers:^n",id))
  for(new a = 1; a <= g_maxplayers; ++a) {
    if(get_user_astats(id, a, stats, body, wpn, 31)) {
      found = 1
      if(stats[0])
        format(wpn, 31, " -- %s", wpn)
      else
        wpn[0] = 0
      get_user_name(a, name, 31)
      pos += format(g_Buffer[pos], 2047-pos, _T("%s -- %d dmg / %d hit(s)%s^n",id), name, stats[6], stats[5], wpn)
    }
  }
  return found
}

/* build list of victims */
getVictims(id) {
  new name[32], wpn[32], stats[9], body[8], found=0
  new pos = format(g_Buffer, 2047, _T("Victims:^n",id))
  for(new a = 1; a <= g_maxplayers; ++a) {
    if(get_user_vstats(id, a, stats, body, wpn, 31)) {
      found = 1
      if(stats[1])
        format(wpn, 31, " -- %s", wpn)
      else
        wpn[0] = 0
      get_user_name(a, name, 31)
      pos += format(g_Buffer[pos], 2047-pos, _T("%s -- %d dmg / %d hit(s)%s^n",id), name, stats[6], stats[5], wpn)
    }
  }
  return found
}

/* build list of hita for AV List */
getHits(id,killer) {
  new stats[9], body[8], pos = 0
  g_Buffer[0] = 0
  get_user_astats(id, killer, stats, body)
  for(new a = 1; a < 8; ++a)
    if(body[a])
      pos += format(g_Buffer[pos], 2047-pos, "%s: %d^n", _T(g_bodyParts[a],id), body[a])
}

/* build list of hits for say hp */
getMyHits(id,killed) {
  new name[32], stats[9], body[8], found = 0
  get_user_name(killed, name, 31)
  new pos = format(g_Buffer, 2047, _T("You hit %s in:",id), name)
  get_user_vstats(id, killed, stats, body)
  for(new a = 1; a < 8; ++a) {
    if(body[a]) {
      found = 1
      pos += format(g_Buffer[pos], 2047-pos, " %s: %d ", _T(g_bodyParts[a],id), body[a])
    }
  }
  return found
}

public eResetHud(id) {
  g_Killers[id][0] = 0
}

public cmdKiller(id) {
  if(!SayHP || !isDXMActive()) {
    client_print(id, print_chat, _T(g_disabledMsg))
    return PLUGIN_HANDLED
  }
  if(g_Killers[id][0]) {
    new name[32], stats[9], body[8], wpn[33], mstats[9], mbody[8]
    get_user_name(g_Killers[id][0], name, 31)
    get_user_astats(id, g_Killers[id][0], stats, body, wpn, 31)
    get_user_vstats(id, g_Killers[id][0], mstats, mbody)
    client_print(id, print_chat,_T("%s killed you with %s from distance of %.2f meters."),
      name, wpn, float(g_Killers[id][2]) * 0.0254)
    client_print(id, print_chat,_T("He did %d damage to you with %d hit(s) and still had %dhp."),
      stats[6], stats[5], g_Killers[id][1])
    client_print(id, print_chat, _T("You did %d damage to him with %d hit(s)."), mstats[6], mstats[5])
    if(getMyHits(id,g_Killers[id][0])) client_print(id, print_chat, g_Buffer)
  }
  else {
    client_print(id, print_chat, _T("You have no killer..."))
  }
  return PLUGIN_CONTINUE
}

public actionStatsMenu(id,key) {
  switch(key) {
    case 7: {
      g_userState[id] = 1 - g_userState[id]
      showStatsMenu(id, g_userPosition[id])
    }
    case 8: showStatsMenu(id, ++g_userPosition[id])
    case 9: showStatsMenu(id, --g_userPosition[id])
    default: {
      new option = g_userPosition[id] * MAX_MENUPOS + key
      new index = g_userPlayers[id][option]
      if(is_user_connected(index)) {
        if(g_userState[id])
          displayRank(index, id)
        else
          displayStats(index, id)
      }
      showStatsMenu(id, g_userPosition[id])
    }
  }
  return PLUGIN_HANDLED
}

showStatsMenu(id,pos) {
  if(pos < 0) return PLUGIN_HANDLED
  new menu_body[512], inum, k = 0, start = pos * MAX_MENUPOS
  get_players(g_userPlayers[id], inum)
  if(start >= inum) start = pos = g_userPosition[id] = 0
  new len = format(menu_body, 511, _T("\yServer Stats\R%d/%d^n\w^n",id),
    pos+1, ((inum / MAX_MENUPOS) + ((inum % MAX_MENUPOS) ? 1 : 0)))
  new name[32], end = start + MAX_MENUPOS, keys = (1<<9)|(1<<7)
  if(end > inum) end = inum
  for(new a = start; a < end; ++a) {
    get_user_name(g_userPlayers[id][a], name, 31)
    keys |= (1<<k)
    len += format(menu_body[len], 511-len, "%d. %s^n", ++k, name)
  }
  len += format(menu_body[len], 511-len, "^n8. %s^n", g_userState[id] ? _T("Show rank",id) : _T("Show stats",id))
  if(end != inum) {
    len += format(menu_body[len], 511-len, _T("^n9. More...^n0. %s",id), pos ? _T("Back",id) : _T("Exit",id))
    keys |= (1<<8)
  }
  else len += format(menu_body[len], 511-len,"^n0. %s", pos ? _T("Back",id) : _T("Exit",id))
  show_menu(id, keys, menu_body, -1, "Server Stats")
  return PLUGIN_HANDLED
}

public NadeCatch(id) {
  if(GreCatch || GreCatchSound) {
    new GreId = read_data(2)
    new catch = ((dod_get_user_team(id) == 1 && GreId == 15) || (dod_get_user_team(id) == 2 && GreId == 16)) ? 1 : 0
    if(catch) {
      if(GreCatch) {
        new player_name[32]
        get_user_name(id, player_name, 31)
        set_hudmessage(200, 100, 0, -1.0, 0.20, 0, 6.0, 6.0, 0.5, 0.15, 1)
        new players[32], pnum
        get_players(players, pnum, "c")
        for(new i = 0; i < pnum; i++) {
          if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
            continue
          show_hudmessage(players[i], _T("Wow! %s caught enemy grenade!"), player_name)
        }
      }
      if(GreCatchSound) play_wav("misc/impressive")
    }
  }
  return PLUGIN_CONTINUE
}

public show_score() {
  if(RoundScore) {
    set_hudmessage(255, 100, 50, -1.0, 0.30, 0, 4.0, 5.0, 0.5, 0.15, 3)
    show_hudmessage(0, _T("Allies %d -- %d Axis^n(%d--%d)"), g_RoundScore[0], g_RoundScore[1], dod_get_team_score(ALLIES), dod_get_team_score(AXIS))
  }
  return PLUGIN_CONTINUE
}

public round_end() {
  if(!isDXMActive())
    return PLUGIN_CONTINUE

  if(RoundScore) {
    new result = read_data(1)
    g_RoundScore[result-3]++
  }

  if(!EndRoundStats) return PLUGIN_CONTINUE

  new g_Buffer2[1024], len, players[32], pnum, stats[9], bodyhits[8]
  get_players(players, pnum)

  new score = 0, kills = 0, hs = 0, damage = 0, hits = 0, who1 = 0, who2 = 0, who3 = 0
  new name1[32], name2[32], name3[32]

  for(new i = 0; i < pnum; ++i) {
    get_user_rstats(players[i], stats, bodyhits)
    if(stats[7] > score) {
      who1 = players[i]
      score = stats[7]
    }
  }
  for(new i = 0; i < pnum; ++i) {
    get_user_rstats(players[i], stats, bodyhits)
    if(stats[0] > kills) {
      who2 = players[i]
      kills = stats[0]
      hs = stats[2]
    }
  }
  for(new i = 0; i < pnum; ++i) {
     get_user_rstats(players[i], stats, bodyhits)
     if(stats[6] > damage) {
        who3 = players[i]
        hits = stats[5]
        damage = stats[6]
     }
  }

  if(is_user_connected(who1)) {
     get_user_name(who1, name1, 31)
  }
  if(is_user_connected(who2)) {
     get_user_name(who2, name2, 31)
  }
  if(is_user_connected(who3)) {
     get_user_name(who3, name3, 31)
  }

  set_hudmessage(100, 200, 0, 0.02, 0.40, 2, 0.01, 5.0, 0.01, 0.01, 3)
  get_players(players, pnum, "c")
  for(new i = 0; i < pnum; i++) {
    len = 0
    if(name1[0]) {
       len += format(g_Buffer2[len], 1023-len,
       _T("Best Score: %s^n%d points^n", players[i]), name1, score)
    }
    if(name2[0]) {
       len += format(g_Buffer2[len], 1023-len,
       _T("Most kills: %s^n%d %s / %d %s^n",players[i]), name2,
       kills, (kills == 1) ? _T("kill",players[i]) : _T("kills",players[i]),
       hs, (hs == 1) ? _T("headshot",players[i]) : _T("headshots",players[i]))
    }
    if(name3[0]) {
       len += format(g_Buffer2[len], 1023-len,
       _T("Most damage: %s^n%d damage / %d %s^n",players[i]), name3, damage,
       hits, (hits == 1) ? _T("hit",players[i]) : _T("hits",players[i]))
    }

    show_hudmessage(players[i], g_Buffer2)
  }

  return PLUGIN_CONTINUE
}

public damage_info(attacker,victim,damage,wpnindex,hitplace,TA) {
  if(TA) {
    if(TAInfo && is_user_alive(victim)) {
      new attacker_name[32]
      get_user_name(attacker, attacker_name, 31)
      client_print(0, print_chat, _T("%s attacked a teammate"), attacker_name)
    }
    return PLUGIN_CONTINUE
  }
  if(BulletDamage) {
    if(attacker == victim || dod_is_melee(wpnindex)) return PLUGIN_CONTINUE
    set_hudmessage(0, 100, 200, 0.45, 0.85, 2, 0.1, 4.0, 0.02, 0.02, 1)
    show_hudmessage(attacker, "%i", damage)
    set_hudmessage(200, 0, 0, 0.55, 0.85, 2, 0.1, 4.0, 0.02, 0.02, 2)
    show_hudmessage(victim, "%i", damage)
  }
  return PLUGIN_CONTINUE
}

/* save state at death */
public death_info(killer,victim,wpnindex,hitplace,TK) {
  new killer_name[32]
  get_user_name(killer, killer_name, 31)
  
  /*new enemygre = (((wpnindex == DODW_HANDGRENADE || wpnindex == DODW_MILLS_BOMB) && dod_get_user_team(killer) == 2)
    || (wpnindex == DODW_STICKGRENADE && dod_get_user_team(killer) == 1)) ? 1 : 0*/
  new enemygre = ((wpnindex == DODW_HANDGRENADE_EX && dod_get_user_team(killer) == 2)
    || (wpnindex == DODW_STICKGRENADE_EX && dod_get_user_team(killer) == 1)) ? 1 : 0

  if(KillingStreak || KillingStreakSound) {
    g_streakKills[victim][1]++
    g_streakKills[victim][0] = 0
  }

  if(TK && TAInfo) {
    client_print(0, print_chat, _T("%s killed a teammate!"), killer_name)
    if(enemygre) {
      set_hudmessage(255, 100, 100, -1.0, 0.15, 1, 6.0, 6.0, 0.5, 0.15, 1)
      show_hudmessage(victim, _T("Oops.. %s killed you trying to throw back enemy grenade.."), killer_name)
    }
  }

  //new grenade = (wpnindex == DODW_HANDGRENADE || wpnindex == DODW_STICKGRENADE || wpnindex == DODW_MILLS_BOMB) ? 1 : 0
  new grenade = (wpnindex == DODW_HANDGRENADE || wpnindex == DODW_STICKGRENADE || wpnindex == DODW_MILLS_BOMB
  || wpnindex == DODW_HANDGRENADE_EX || wpnindex == DODW_STICKGRENADE_EX) ? 1 : 0
  new headshot = (hitplace == HIT_HEAD) ? 1 : 0
  new selfKill = (killer == victim) ? 1 : 0

  new victim_name[32]
  get_user_name(victim, victim_name, 31)
  new Float:StatsTime = get_cvar_float("amx_dodstats_duration")

  if(ShowVictims && isDXMActive() && getVictims(victim)) {
    set_hudmessage(0, 80, 220, 0.55, 0.60, 0, StatsTime, 12.0, 1.0, 2.0, 4)
    show_hudmessage(victim, g_Buffer)
  }
  if(ShowAttackers && isDXMActive() && getAttackers(victim)) {
    set_hudmessage(220, 80, 0, 0.55, 0.35, 0, StatsTime, 12.0, 1.0, 2.0, 3)
    show_hudmessage(victim, g_Buffer)
  }

  new players[32], pnum
  get_players(players, pnum, "c")
  
  if(selfKill && grenade) {
    if(GrenadeSuicide) {
      set_hudmessage(255, 100, 100, -1.0, 0.15, 1, 6.0, 6.0, 0.5, 0.15, 1)
      if(!enemygre) {
        for(new i = 0; i < pnum; i++) {
          if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
            continue
          show_hudmessage(players[i], _T(g_SHeMessages[random_num(0,3)]), victim_name)
        }
      }
      else {
        for(new i = 0; i < pnum; i++) {
          if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
            continue
          show_hudmessage(players[i], _T("%s failed to throw back enemy grenade.."), victim_name)
        }
      }
    }
    if(GrenadeSuicideSound) play_wav("djeyl/witch")
  }

  if(selfKill || TK)
    return PLUGIN_CONTINUE

  new vorigin[3], korigin[3]
  get_user_origin(victim, vorigin)
  get_user_origin(killer, korigin)
  g_Killers[victim][0] = killer
  g_Killers[victim][1] = get_user_health(killer)
  g_Killers[victim][2] = get_distance(vorigin, korigin)
  g_DeathStats[victim] = get_gametime() + StatsTime

  if(ShowKiller && isDXMActive()) {
    new stats[9], body[8], wpn[33], mstats[9], mbody[8]

    get_user_astats(victim, killer, stats, body, wpn, 31)
    get_user_vstats(victim, killer, mstats, mbody)
    set_hudmessage(220, 80, 0, 0.05, 0.15, 0, StatsTime, 12.0, 1.0, 2.0, 1)
    getHits(victim, killer)
    show_hudmessage(victim, _T("%s killed you with %s^nfrom distance of %.2f meters.^nHe did %d damage to you with %d hit(s)^nand still has %dhp.^nYou did %d damage to him with %d hit(s).^nHe hits you in:^n%s"),
      killer_name, wpn, float(g_Killers[victim][2]) * 0.0254,stats[6], stats[5],
      g_Killers[victim][1], mstats[6], mstats[5], g_Buffer)
  }

  if(KillerHp) {
    new kmsg[128]
    format(kmsg, 127, _T("%s still has %dhp",victim), killer_name, g_Killers[victim][1])
    client_print(victim, print_console, kmsg)
    set_hudmessage(255, 255, 255, 0.02, 0.9, 2, 1.5, 3.0, 0.02, 5.0, 2)
    show_hudmessage(victim, kmsg)
  }

  if(KillingStreak || KillingStreakSound) {
    g_streakKills[killer][0]++
    g_streakKills[killer][1] = 0
    new a = g_streakKills[killer][0] - 3
    if((a > -1) && !(a % 2)) {
      if((a >>= 1) > 6) a = 6
      if(KillingStreak) {
        set_hudmessage(0, 100, 255, 0.05, 0.55, 2, 0.02, 6.0, 0.01, 0.1, 3)
        for(new i = 0; i < pnum; i++) {
          if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
            continue
          show_hudmessage(players[i], _T(g_KillingMsg[a]), killer_name)
        }
      }
      if(KillingStreakSound) play_wav(g_Sounds[a])
    }
  }

  if(MultiKill || MultiKillSound) {
      g_multiKills[killer][0]++
      g_multiKills[killer][1] += headshot
      new param[2]
      param[0] = killer
      param[1] = g_multiKills[killer][0]
      set_task(4.0 + float(param[1]), "checkKills", 0, param, 2)
  }

  if(dod_is_melee(wpnindex) && (KnifeKill || KnifeKillSound)) {
    if(KnifeKill) {
      set_hudmessage(255, 100, 100, -1.0, 0.15, 1, 6.0, 6.0, 0.5, 0.15, 1)
      for(new i = 0; i < pnum; i++) {
        if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
          continue
        show_hudmessage(players[i], _T(g_KnifeMsg[random_num(0,3)]), killer_name, victim_name)
      }
    }
    if(KnifeKillSound) play_wav("misc/humiliation")
  }

  if(grenade) {
    if(enemygre) {
      if(EnemyGreKill) {
        set_hudmessage(255, 100, 100, -1.0, 0.15, 1, 6.0, 6.0, 0.5, 0.15, 1)
        for(new i = 0; i < pnum; i++) {
          if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
            continue
          show_hudmessage(players[i], _T("OMG! %s is grenade master!!!"), killer_name)
        }
      }
      if(EnemyGreKillSound) play_wav("misc/godlike")
    }
    else {
      if(GrenadeKill) {
        set_hudmessage(255, 100, 100, -1.0, 0.15, 1, 6.0, 6.0, 0.5, 0.15, 1)
        for(new i = 0; i < pnum; i++) {
          if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
            continue
          show_hudmessage(players[i], _T(g_HeMessages[random_num(0,3)]), killer_name, victim_name)
        }
      }
      if(GrenadeKillSound) play_wav("djeyl/grenade")
    }
  }

  if(headshot && (HeadShotKill || HeadShotKillSound) && !dod_is_melee(wpnindex)) {
    if(HeadShotKill) {
      new weapon[32], message[128]
      dod_get_wpnname(wpnindex, weapon, 31)
      set_hudmessage(100, 100, 255, -1.0, 0.19, 0, 6.0, 6.0, 0.5, 0.15, 1)
      for(new i = 0; i < pnum; i++) {
        if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
          continue
        format(message, 127, _T(g_HeadShots[random_num(0,6)], players[i]))
        replace(message, 127, "$vn", victim_name)
        replace(message, 127, "$wn", weapon)
        replace(message, 127, "$kn", killer_name)
        show_hudmessage(players[i], message)
      }
    }
    if(HeadShotKillSound) {
      client_cmd(killer, "spk misc/headshot")
      client_cmd(victim, "spk misc/headshot")
    }
  }

  if(DoubleKill || DoubleKillSound) {
    new Float:nowtime = get_gametime()
    if(g_prevKill == nowtime && g_prevKillerId == killer) {
      g_KillCount++
      set_task(0.01, "showDoubleKill")
    }
    else {
      g_KillCount = 1
    }
    g_prevKill = nowtime
    g_prevKillerId = killer
  }

  if(g_vexdRunning) {
    if(AirKill && !(entity_get_int(victim, EV_INT_flags) & FL_ONGROUND)) {
      new message[128]
      set_hudmessage(100, 100, 255, -1.0, 0.23, 0, 6.0, 6.0, 0.5, 0.15, 1)
      for(new i = 0; i < pnum; i++) {
        if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
          continue
        copy(message, 127, _T(g_AirKillMessages[random_num(0,2)],players[i]))
        replace(message, 127, "$vn", victim_name)
        replace(message, 127, "$kn", killer_name)
        show_hudmessage(players[i], message)
      }
    }
    if(WaterKill && (entity_get_int(victim, EV_INT_waterlevel) == 2 || entity_get_int(victim, EV_INT_waterlevel) == 3)) {
      new message[128]
      set_hudmessage(100, 100, 255, -1.0, 0.23, 0, 6.0, 6.0, 0.5, 0.15, 1)
      for(new i = 0; i < pnum; i++) {
        if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
          continue
        copy(message, 127, _T(g_WaterKillMessages[random_num(0,2)], players[i]))
        replace(message, 127, "$vn", victim_name)
        replace(message, 127, "$kn", killer_name)
        show_hudmessage(players[i], message)
      }
    }
  }

  return PLUGIN_CONTINUE
}

public client_kill(id) {
  if(Suicide && is_user_alive(id)) {
    new name[32]
    get_user_name(id, name, 31)
    set_hudmessage(255, 100, 100, -1.0, 0.25, 1, 6.0, 6.0, 0.5, 0.15, 1)
    new players[32], pnum
    get_players(players, pnum, "c")
    for(new i = 0; i < pnum; i++) {
      if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
        continue
      show_hudmessage(players[i], _T(g_SuicideMessages[random_num(0,1)]), name)
    }
  }
}

public showDoubleKill() {
  new pos = g_KillCount - 2
  if(pos > 2) pos = 2
  if(DoubleKill) {
    new name[32]
    get_user_name(g_prevKillerId, name, 31)
    set_hudmessage(65, 102, 158, -1.0, 0.25, 0, 6.0, 6.0, 0.5, 0.15, 3)
    new players[32], pnum
    get_players(players, pnum, "c")
    for(new i = 0; i < pnum; i++) {
      if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
        continue
      show_hudmessage(players[i], _T(g_DoubleKillMsg[pos]), name, g_KillCount)
    }
  }
  if(DoubleKillSound) play_wav(g_DoubleKillSound[pos])
}

public checkKills(param[]) {
  new id = param[0]
  new a = param[1]
  if(a == g_multiKills[id][0]) {
    a -= 3
    if(a > -1) {
      if(MultiKill) {
        new name[32]
        get_user_name(id, name, 31)
        set_hudmessage(255, 0, 100, 0.05, 0.65, 2, 0.02, 6.0, 0.01, 0.1, 2)
        if(a > 6) a = 6
        new players[32], pnum
        get_players(players, pnum, "c")
        for(new i = 0; i < pnum; i++) {
          if(g_Killers[players[i]][0] && g_DeathStats[players[i]] > get_gametime())
            continue
          show_hudmessage(players[i], _T(g_MultiKillMsg[a]), name, g_multiKills[id][0], g_multiKills[id][1])
        }
      }
      if(MultiKillSound) play_wav(g_Sounds[a])
    }
    g_multiKills[id] = {0, 0}
  }
}

/***************
  LeadSounds
****************/

new LeaderScore
new NumOfLeaders
new LeaderID
new PScore[33]

public client_disconnect(id) {
  if(!LeadSounds || isDXMActive()) return PLUGIN_CONTINUE
  if(PScore[id] == LeaderScore && LeaderScore > 0) {
    NumOfLeaders--
    PScore[id] = 0
    if(NumOfLeaders == 0) {
      LeaderScore = 0
      for(new i = 1; i <= g_maxplayers; i++)
        if(PScore[i] > LeaderScore) {
          LeaderScore = PScore[i]
          NumOfLeaders = 1
          LeaderID = i
        }
        else if(PScore[i] == LeaderScore)
          NumOfLeaders ++

      if(LeaderScore == 0)
        NumOfLeaders = 0
      else if(NumOfLeaders == 1)
        client_cmd(LeaderID, "spk misc/takenlead")
      else if(NumOfLeaders > 1)
        for(new i = 1; i <= g_maxplayers; i++)
          if(PScore[i] == LeaderScore)
            client_cmd(i, "spk misc/tiedlead")
      //else no players on server or have 0 score
    }
    else if(NumOfLeaders == 1)
      if(LeaderID != id) {
        client_cmd(LeaderID, "spk misc/takenlead")
      }
      else {
        for(new i = 1; i <= g_maxplayers; i++)
        if(PScore[i] == LeaderScore) client_cmd(i, "spk misc/takenlead")
      }
  }
  else PScore[id] = 0
  return PLUGIN_CONTINUE
}

public get_score() {
  if(!LeadSounds || !isDXMActive()) return PLUGIN_CONTINUE
  new PlayerID = read_data(1)
  new PlayerScore = read_data(2)

  if(PlayerScore > PScore[PlayerID]) {
    PScore[PlayerID] = PlayerScore

    if(PlayerScore > LeaderScore) {
      if(NumOfLeaders == 1) {
        if(LeaderID != PlayerID) {
          client_cmd(LeaderID, "spk misc/lostlead")
          client_cmd(PlayerID, "spk misc/takenlead")
        }
      }
      else if(NumOfLeaders > 1) {
        for(new i = 1; i <= g_maxplayers; i++)
          if(PScore[i] == LeaderScore  && i != PlayerID)
            client_cmd(i, "spk misc/lostlead")
        client_cmd(PlayerID, "spk misc/takenlead")
      }
      else if(NumOfLeaders == 0) { // start
        for(new i = 1; i <= g_maxplayers; i++)
          if(i != PlayerID && is_user_connected(i)) client_cmd(i, "spk misc/lostlead")
        client_cmd(PlayerID, "spk misc/takenlead")
      }

      LeaderScore = PlayerScore
      LeaderID = PlayerID
      NumOfLeaders = 1
    }
    else if(PlayerScore == LeaderScore) {
      if(NumOfLeaders == 1) client_cmd(LeaderID, "spk misc/tiedlead")
      client_cmd(PlayerID, "spk misc/tiedlead")
      NumOfLeaders++
    }
  }
  return PLUGIN_CONTINUE
}

public play_wav(sound[]) {
  new players[32], inum
  get_players(players, inum, "c")
  for(new i = 0; i < inum; i++) {
    if(is_user_connecting(players[i])) continue
    client_cmd(players[i], "spk %s", sound)
  }
}

isDXMActive() {
  if ( get_cvar_num("dodstats_pause") )
    return 0
  return 1
}
